#!/bin/bash
# A3P/run_tests.sh
# created lun. nov. 13 01:55:52 CET 2017 by Yann Guidon (whygee@f-cpu.org)
# version ven. nov. 17 01:11:13 CET 2017
# version mar. nov. 19 04:24:24 CET 2019
# version mer. nov. 27 05:05:21 CET 2019
# version mar. déc.  3 07:37:49 CET 2019 : the whole script takes 72 seconds
#
# Released under the GNU AGPLv3 license

ghdl -v |grep "mcode" && echo "This script does not support mcode, use GHDL with GCC or LLVM backend."

echo
echo  'This script will run exhaustive self-tests and will'
echo  'take "a while", depending on your CPU and software.'
echo  '(about one minute on my i7 PC)'
echo  'You may interrupt it (CTRL+C) if needed. Please report errors.'
echo

DIRLIST="test1_simple test2_INC8 test3_ALU8"

# compile the PA3 gates library
echo -n '--> going to ' ; pushd proasic3v2
./build.sh || DIRLIST=""
echo -n '<-- back to ' ; popd

# compile the Y8 library
echo -n '--> going to ' ; pushd Y8
./build.sh || DIRLIST=""
echo -n '<-- back to ' ; popd

# run this to perform sanity checks with GHDL
# and also cleanup all temporary and object files
for DIR in $DIRLIST
do
  echo -n '--> going to ' ; pushd $DIR
  ./test.sh ||break
  echo -n '<-- back to ' ; popd
done
